using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using System.Data.Common;

namespace RservationsModeConnect
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	/// 
 struct PLACE
 {
  public int Place;
  public int Occup;
  public string Occupant;
 }
	public class Form1 : System.Windows.Forms.Form
	{
  private System.Windows.Forms.OpenFileDialog ofdBD;
  private System.ComponentModel.IContainer components;
  PLACE[] tabPlaces;
  private System.Windows.Forms.ContextMenu contextMenu;
  Rectangle[] tabRect;   // tableau des rectangles des places
  int N=20, X=30, Y=70, W=50, H=50;   // Nombre de rectangles, coord du csg, largeur et hauteur d'un rectangle
  string connStr;
  DbConnection oConn;
  DbTransaction oTrans;
  private System.Windows.Forms.MenuItem miRserver;
  DbCommand oCmd;
  private System.Windows.Forms.Button bRinit;
  private System.Windows.Forms.Label label1;
  private System.Windows.Forms.Button bConfirmer;
  private System.Windows.Forms.MenuItem miAnnuler;
  private System.Windows.Forms.TextBox zeNom;
  private System.Windows.Forms.Label label2;
  private System.Windows.Forms.ToolTip toolTip1;
  private System.Windows.Forms.Button bMajAffichage;
  int PlaceCourante;
  string sNomBD;
		public Form1()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
   tabPlaces = new PLACE[N];
   tabRect = new Rectangle[N];
   for (int li=0; li<4; li++)
    for (int col=0; col<5; col++)
    {
     tabRect[li*5+col] = new Rectangle(X+col*W, Y+li*H, W, H);
    }

   // demander le nom de la base de donnes
   ofdBD.InitialDirectory = Environment.CurrentDirectory;
   ofdBD.Filter = "Access|*.mdb";
   DialogResult res = ofdBD.ShowDialog();
   if (res == DialogResult.OK)
   {
    sNomBD = ofdBD.FileName;
    LireEtatPlaces();
   }
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
   this.components = new System.ComponentModel.Container();
   System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(Form1));
   this.ofdBD = new System.Windows.Forms.OpenFileDialog();
   this.contextMenu = new System.Windows.Forms.ContextMenu();
   this.miRserver = new System.Windows.Forms.MenuItem();
   this.miAnnuler = new System.Windows.Forms.MenuItem();
   this.bRinit = new System.Windows.Forms.Button();
   this.label1 = new System.Windows.Forms.Label();
   this.bConfirmer = new System.Windows.Forms.Button();
   this.zeNom = new System.Windows.Forms.TextBox();
   this.label2 = new System.Windows.Forms.Label();
   this.toolTip1 = new System.Windows.Forms.ToolTip(this.components);
   this.bMajAffichage = new System.Windows.Forms.Button();
   this.SuspendLayout();
   // 
   // ofdBD
   // 
   this.ofdBD.Title = "Spcifier o se trouve le fichier commun Rservations.mdb";
   // 
   // contextMenu
   // 
   this.contextMenu.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
                                                                            this.miRserver,
                                                                            this.miAnnuler});
   this.contextMenu.Popup += new System.EventHandler(this.contextMenu_Popup);
   // 
   // miRserver
   // 
   this.miRserver.Index = 0;
   this.miRserver.Text = "Proposer  la rservation";
   this.miRserver.Click += new System.EventHandler(this.miProposerRservation_Click);
   // 
   // miAnnuler
   // 
   this.miAnnuler.Index = 1;
   this.miAnnuler.Text = "Annuler la rservation";
   this.miAnnuler.Click += new System.EventHandler(this.miAnnuler_Click);
   // 
   // bRinit
   // 
   this.bRinit.Location = new System.Drawing.Point(368, 32);
   this.bRinit.Name = "bRinit";
   this.bRinit.Size = new System.Drawing.Size(120, 40);
   this.bRinit.TabIndex = 0;
   this.bRinit.Text = "Rinitialiser la base de donnes";
   this.bRinit.Click += new System.EventHandler(this.bRinit_Click);
   // 
   // label1
   // 
   this.label1.Location = new System.Drawing.Point(8, 8);
   this.label1.Name = "label1";
   this.label1.Size = new System.Drawing.Size(336, 40);
   this.label1.TabIndex = 1;
   this.label1.Text = "Rservez une ou plusieurs places par un clic avec le bouton droit. Confirmez ensu" +
    "ite la ou les rservations.";
   // 
   // bConfirmer
   // 
   this.bConfirmer.Location = new System.Drawing.Point(376, 248);
   this.bConfirmer.Name = "bConfirmer";
   this.bConfirmer.Size = new System.Drawing.Size(112, 40);
   this.bConfirmer.TabIndex = 2;
   this.bConfirmer.Text = "Confirmer la ou les rservations";
   this.bConfirmer.Click += new System.EventHandler(this.bConfirmer_Click);
   // 
   // zeNom
   // 
   this.zeNom.Location = new System.Drawing.Point(368, 200);
   this.zeNom.Name = "zeNom";
   this.zeNom.Size = new System.Drawing.Size(168, 20);
   this.zeNom.TabIndex = 3;
   this.zeNom.Text = "";
   // 
   // label2
   // 
   this.label2.Location = new System.Drawing.Point(368, 184);
   this.label2.Name = "label2";
   this.label2.Size = new System.Drawing.Size(152, 16);
   this.label2.TabIndex = 4;
   this.label2.Text = "Nom pour lequel on rserve :";
   // 
   // bMajAffichage
   // 
   this.bMajAffichage.Location = new System.Drawing.Point(368, 96);
   this.bMajAffichage.Name = "bMajAffichage";
   this.bMajAffichage.Size = new System.Drawing.Size(120, 48);
   this.bMajAffichage.TabIndex = 5;
   this.bMajAffichage.Text = "Mise  jour de l\'affichage";
   this.bMajAffichage.Click += new System.EventHandler(this.bMajAffichage_Click);
   // 
   // Form1
   // 
   this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
   this.ClientSize = new System.Drawing.Size(568, 325);
   this.Controls.AddRange(new System.Windows.Forms.Control[] {
                                                              this.bMajAffichage,
                                                              this.label2,
                                                              this.zeNom,
                                                              this.bConfirmer,
                                                              this.label1,
                                                              this.bRinit});
   this.Icon = ((System.Drawing.Icon)(resources.GetObject("$this.Icon")));
   this.Name = "Form1";
   this.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen;
   this.Text = "Rservations en mode connect";
   this.MouseUp += new System.Windows.Forms.MouseEventHandler(this.Form1_MouseUp);
   this.Paint += new System.Windows.Forms.PaintEventHandler(this.Form1_Paint);
   this.MouseMove += new System.Windows.Forms.MouseEventHandler(this.Form1_MouseMove);
   this.ResumeLayout(false);

  }
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}
  private void Form1_Paint(object sender, System.Windows.Forms.PaintEventArgs e)
  {
   Brush br=null;
   for (int i=0; i<N; i++) 
   {
    switch (tabPlaces[i].Occup)
    {
     case 0 : br = new SolidBrush(Color.Lime); break;
     case 1 : br = new SolidBrush(Color.Red); break;
     case 2 : br = new SolidBrush(Color.Yellow); break;
    }
    e.Graphics.FillRectangle(br, tabRect[i]); 
    e.Graphics.DrawString((i+1).ToString(), 
                          new Font("Arial", 10), new SolidBrush(Color.Black), 
                          tabRect[i].Left+5, tabRect[i].Bottom-20);
   }    
   e.Graphics.DrawRectangles(new Pen(Color.Black, 2), tabRect);
 
  }

  private void Form1_MouseUp(object sender, System.Windows.Forms.MouseEventArgs e)
  {
   if (e.Button == MouseButtons.Right)
    if (PlaceCourante != -1) contextMenu.Show(this, new Point(e.X, e.Y));
  }

  private void miProposerRservation_Click(object sender, System.EventArgs e)
  {
    tabPlaces[PlaceCourante-1].Occup = 2;
    tabPlaces[PlaceCourante-1].Occupant = zeNom.Text;
    Invalidate(false);
  }

  private void bRinit_Click(object sender, System.EventArgs e)
  {
   try
   {
    oCmd = oConn.CreateCommand();
    oCmd.CommandText = "UPDATE Spectacle Set Occup=0, Occupant=NULL ";
    oConn.Open();
    int n = oCmd.ExecuteNonQuery();
    // Mettre  jour la reprsentation  l'cran
    for (int i = 0; i < N; i++) { tabPlaces[i].Occup = 0; tabPlaces[i].Occupant = ""; }
    Invalidate(false);
   }
   catch (Exception exc)
   {
    MessageBox.Show(exc.Message);
   }
   finally
   {
    oConn.Close();
   }
  }

  private void bConfirmer_Click(object sender, System.EventArgs e)
  {
   try
   {
    oConn.Open();
    oTrans = oConn.BeginTransaction();
    oCmd = oConn.CreateCommand();

    for (int i = 0; i < N; i++)
    {
     if (tabPlaces[i].Occup == 2)
     {
      oCmd.CommandText = "UPDATE Spectacle Set Occup=1, Occupant='" + tabPlaces[i].Occupant
                         + "' WHERE Place=" + tabPlaces[i].Place + " AND Occup=0";
      oCmd.Transaction = oTrans;
      int n = oCmd.ExecuteNonQuery();
      if (n == 0)
      {
       MessageBox.Show("Dsol, la place " + (i + 1) + " vient d'tre rserve");
       oTrans.Rollback();
       LireEtatPlaces();
       Invalidate(false);
      }
     }
    }
    oTrans.Commit();
    LireEtatPlaces();
    Invalidate(false);
   }
   catch (Exception exc)
   {
    MessageBox.Show(exc.Message);
   }
   finally
   {
    oConn.Close();
   }
  }

  private void miAnnuler_Click(object sender, System.EventArgs e)
  {
   tabPlaces[PlaceCourante-1].Occup = 0;
   tabPlaces[PlaceCourante-1].Occupant = "";
   Invalidate(false);
  }

  private void contextMenu_Popup(object sender, System.EventArgs e)
  {
   miRserver.Enabled = tabPlaces[PlaceCourante-1].Occup == 0;
   miAnnuler.Enabled = tabPlaces[PlaceCourante-1].Occup == 2;
  }

  private void Form1_MouseMove(object sender, System.Windows.Forms.MouseEventArgs e)
  {
   // retrouver le numro de la place
   PlaceCourante = -1;
   for (int i=0; i<N; i++)
   {
    if (tabRect[i].Contains(e.X, e.Y))
    {
     PlaceCourante = i+1;
     break;
    }
   }
   string s = PlaceCourante!=-1 && tabPlaces[PlaceCourante-1].Occup == 1 ? tabPlaces[PlaceCourante-1].Occupant : "";
   toolTip1.SetToolTip(this, s);
  }

  void LireEtatPlaces()
  {
    connStr = @"Provider=Microsoft.Jet.OLEDB.4.0;Data Source='" + sNomBD + "'";
    try
    {
     DbProviderFactory dbpf = DbProviderFactories.GetFactory("System.Data.OleDb");
     oConn = dbpf.CreateConnection();
     oConn.ConnectionString = connStr;
     oConn.Open();
     oCmd = oConn.CreateCommand();
     oCmd.CommandText = "SELECT * FROM Spectacle";
     DbDataReader rdr = oCmd.ExecuteReader();
     if (rdr != null)
     {
      int i=0;
      while (rdr.Read())
      {
       tabPlaces[i].Place = (int)rdr["Place"];
       tabPlaces[i].Occup = (int)rdr["Occup"];
       object o = rdr["Occupant"];
       if (o is string) tabPlaces[i].Occupant = (string)rdr["Occupant"];
       else tabPlaces[i].Occupant = "";
       i++;
      }
      oConn.Close();
     }
    }
    catch (Exception exc)
    {
     MessageBox.Show(exc.Message);
    }
    Invalidate(false);
  }

  private void bMajAffichage_Click(object sender, System.EventArgs e)
  {
   LireEtatPlaces();
  }
	}
}
